package model;

/**
 * The test class CPU.
 *
 * @author  Kristian Torp, torp (at) cs (dot) aau (dot) dk
 * @version 1.0
 */
public class TestCPU extends junit.framework.TestCase{
    private CPU intel1;
    private CPU intel2;
    private CPU intel3;

    /**
     * Default constructor for test class TestCPU
     */
    public TestCPU(){
        super();
    }

    /**
     * Sets up the test fixture.
     */
    protected void setUp(){
        try{
            intel1 = new CPU("Intel", "Celeron",  419.50, 1700);
            intel2 = new CPU("Intel", "Celeron",  419.50, 1700, CPU.MHZ);
            intel3 = new CPU("Intel", "Celeron",  419.50, 1700, CPU.GHZ);
        } 
        catch (Exception e){
            assertTrue(e.getMessage(), false);
        }
    }

    public void testIntel1(){
        assertEquals("Make not equal", intel1.getMake(), "Intel");
        assertEquals("Model not equal", intel1.getModel(), "Celeron");
        assertTrue("Price not equal", intel1.getPrice() == 419.50);
        assertEquals("Frequency not equal", intel1.getFrequence(), 1700);
    }
    
    public void testToString(){
        String in1 = "" + intel1;
        assertTrue("tostring failed", in1.length() > 0);
    }

    public void testEquals(){
        assertTrue("CPUs are not equal", intel1.equals(intel2));
        assertFalse("CPUs are equal", intel1.equals(intel3));
    }

    public void testClone(){
        CPU intel1Clone = (CPU)intel1.clone();
        assertEquals("CPU clones are not equal (first way)", intel1, intel1Clone);
        assertEquals("CPU clones are not equal (second way)", intel1Clone, intel1);
    }
}
