package model;

/**
 * The test class HardDrive.
 *
 * @author  Kristian Torp, torp (at) cs (dot) aau (dot) dk
 * @version 1.0
 */
public class TestHardDrive extends junit.framework.TestCase{
    private HardDrive seagate1;
    private HardDrive seagate2;
    private HardDrive seagate3;

    /**
     * Default constructor for test class TestHardDrive
     */
    public TestHardDrive(){
        super();
    }

    /**
     * Sets up the test fixture.
     */
    protected void setUp(){
        try{
            seagate1 = new HardDrive("Seagate", "Deskstar",  1000.00, 40);
            seagate2 = new HardDrive("Seagate", "Deskstar",  1000.00, 40, Storage.GB);
            seagate3 = new HardDrive("Seagate", "Deskstar",  2222.22, 70, Storage.MB);
        } 
        catch (Exception e){
            assertTrue(e.getMessage(), false);
        }
    }

    public void testIntel1(){
        assertEquals("Make not equal", seagate1.getMake(), "Seagate");
        assertEquals("Model not equal", seagate1.getModel(), "Deskstar");
        assertTrue("Price not equal", seagate1.getPrice() == 1000.00);
        assertEquals("Size not equal", seagate1.getSize(), 40);
        assertEquals("Unit not equal", seagate1.getUnit(), Storage.GB);
    }
    
    public void testEquals(){
        assertTrue("HardDrives are not equal", seagate1.equals(seagate2));
        assertFalse("HardDrives are equal", seagate1.equals(seagate3));
    }
    
    public void testToString(){
        String in1 = "" + seagate1;
        assertTrue("tostring failed", in1.length() > 0);
    }

    public void testClone(){
        HardDrive seagate11Clone = (HardDrive)seagate1.clone();
        assertEquals("Hard drives are not equal (first way)", seagate1, seagate11Clone);
        assertEquals("Hard drives are not equal (second way)", seagate11Clone, seagate1);
    }
}
