package model;

/**
 * The test class main board.
 *
 * @author  Kristian Torp, torp (at) cs (dot) aau (dot) dk
 * @version 1.0
 */
public class TestMainBoard extends junit.framework.TestCase{
    private MainBoard asus1;
    private MainBoard asus2;
    private MainBoard asus3;

    /**
     * Default constructor for test class TestCPU
     */
    public TestMainBoard(){
        super();
    }

    /**
     * Sets up the test fixture.
     */
    protected void setUp(){
        try{
            asus1 = new MainBoard("Asus", "A7N-266-VM",  500.05, "Some information");
            asus2 = new MainBoard("Asus", "A7N-266-VM",  500.05, "Some information");
            asus3 = new MainBoard("Asus", "A7N-27-VM",  500.05, "Some information");
        } 
        catch (Exception e){
            assertTrue(e.getMessage(), false);
        }
    }

    public void testAsus1(){
        assertEquals("Make not equal", asus1.getMake(), "Asus");
        assertEquals("Model not equal", asus1.getModel(), "A7N-266-VM");
        assertTrue("Price not equal", asus1.getPrice() == 500.05);
        assertEquals("Information not equal", asus1.getInformation(), "Some information");
    }
    
    public void testEquals(){
        assertTrue("Main boards are not equal", asus1.equals(asus2));
        assertFalse("Main boards are equal", asus1.equals(asus3));
    }
    
    public void testToString(){
        String in1 = "" + asus1;
        assertTrue("tostring failed", in1.length() > 0);
    }

    public void testClone(){
        MainBoard asus1Clone = (MainBoard)asus1.clone();
        assertEquals("Main boards are not equal (first way)", asus1, asus1Clone);
        assertEquals("Main boards are not equal (second way)", asus1Clone, asus1);
    }
}
