package model;

/**
 * The test class RAM.
 * 
 * @author Kristian Torp, torp (at) cs (dot) aau (dot) dk
 * @version 1.0
 */
public class TestPC extends junit.framework.TestCase {
	private PC pc1;

	private PC pc2;

	private PC pc3;

	private MainBoard mainBoard1;

	private MainBoard mainBoard2;

	private MainBoard mainBoard2_1;

	private CPU intel1;

	private CPU intel2;

	private CPU intel3;

	private CPU amd1;

	private CPU amd1_1;

	private HardDrive seagate1;

	private HardDrive seagate2;

	private HardDrive hitachi1;

	private HardDrive hitachi1_1;

	private RAM kingston1;

	private RAM kingston2;

	private RAM micron1;

	private RAM micron1_1;

	/**
	 * Default constrouctor
	 */
	public TestPC() {
		super();
	}

	/**
	 * Sets up the test fixture.
	 */
	protected void setUp() {
		try {
			mainBoard1 = new MainBoard("Asus", "A7N-266-VM", 500.00,
					"Some information");
			mainBoard2 = new MainBoard("Asus", "A7N-266-VM", 5000.00,
					"Some information");
			mainBoard2_1 = new MainBoard("Asus", "A7N-266-VM", 5000.00,
					"Some information");

			intel1 = new CPU("Intel", "Celeron", 1500.00, 1700);
			intel2 = new CPU("Intel", "Celeron", 1500.00, 1700);
			intel3 = new CPU("Intel", "Celeron", 1500.00, 1700);
			amd1 = new CPU("AMD", "Athlon 64 2800+", 1199.00, 2200, CPU.MHZ);
			amd1_1 = new CPU("AMD", "Athlon 64 2800+", 1199.00, 2200, CPU.MHZ);

			seagate1 = new HardDrive("Seagate", "Deskstar", 1000.00, 40);
			seagate2 = new HardDrive("Seagate", "Deskstar", 1000.00, 40,
					Storage.GB);
			hitachi1 = new HardDrive("Hitachi", "Deskstar", 1000.00, 40);
			hitachi1_1 = new HardDrive("Hitachi", "Deskstar", 1000.00, 40);

			kingston1 = new RAM("Kingston", "1GB", 1000.00, 40);
			kingston2 = new RAM("Kingston", "1GB", 1000.00, 40);
			micron1 = new RAM("Micron", "1/2GB", 500.00, 500);
			micron1_1 = new RAM("Micron", "1/2GB", 500.00, 500);

			// pc that is bulid piece by piece
			pc1 = new PC("IBM", "Thinkpad");
			// pc build in one go
			pc2 = new PC("Dell", "Dimension", mainBoard2, amd1, hitachi1,
					micron1);
			// same as pc2
			pc3 = new PC("Dell", "Dimension", mainBoard2_1, amd1_1, hitachi1_1,
					micron1_1);

		} catch (Exception e) {
			assertTrue(e.getMessage(), false);
		}
	}

	public void testPC1Get() {
		assertEquals("Make not equal", pc1.getMake(), "IBM");
		assertEquals("Model not equal", pc1.getModel(), "Thinkpad");
		double price = pc1.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 0", price == 0.0);

		pc1.addMainBoard(mainBoard1);
		price = pc1.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 500.00",
				price == 500.0);

		pc1.addCPU(intel1);
		pc1.addCPU(intel2);
		pc1.addCPU(intel3);
		price = pc1.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 5000.00",
				price == 5000.0);

		pc1.addHardDrive(seagate1);
		pc1.addHardDrive(seagate2);
		price = pc1.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 7000.00",
				price == 7000.0);

		pc1.addRamBlock(kingston1);
		pc1.addRamBlock(kingston2);
		price = pc1.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 9000.00",
				price == 9000.0);

	}

	public void testPC2Get() {
		assertEquals("Make not equal", pc2.getMake(), "Dell");
		assertEquals("Model not equal", pc2.getModel(), "Dimension");
		double price = pc2.getPrice();
		assertTrue("Price wrong is " + price + " .Assumed 7699.\n" + pc2,
				price == 7699.00);
	}

	public void testEquals() {
		assertEquals("Two Dells are not equal", pc2, pc3);
		assertFalse("Dell and IBM are equal", pc1.equals(pc3));
	}

	public void testClone() {
		PC del1Clone = (PC) pc2.clone();
		assertEquals("Two Dells are not equal (first way)", pc2, del1Clone);
		assertEquals("Two Dells are not equal (second way)", del1Clone, pc2);
	}
}