package model;

/**
 * The test class RAM.
 * 
 * @author Kristian Torp, torp (at) cs (dot) aau (dot) dk
 * @version 1.0
 */
public class TestRAM extends junit.framework.TestCase {
	private RAM kingston1;

	private RAM kingston2;

	private RAM kingston3;

	/**
	 * Default constructor
	 */
	public TestRAM() {
		super();
	}

	/**
	 * Sets up the test fixture.
	 */
	protected void setUp() {
		try {
			kingston1 = new RAM("Kingston", "1GB", 1000.00, 40);
			kingston2 = new RAM("Kingston", "1GB", 1000.00, 40, Storage.MB);
			kingston3 = new RAM("Kingston", "1GB", 2222.22, 70, Storage.GB);
		} catch (Exception e) {
			assertTrue(e.getMessage(), false);
		}
	}

	public void testKingston1() {
		assertEquals("Make not equal", kingston1.getMake(), "Kingston");
		assertEquals("Model not equal", kingston1.getModel(), "1GB");
		assertTrue("Price not equal", kingston1.getPrice() == 1000.00);
		assertEquals("Size not equal", kingston1.getSize(), 40);
		assertEquals("Unit not equal", kingston1.getUnit(), Storage.MB);
	}

	public void testEquals() {
		assertTrue("HardDrives are not equal", kingston1.equals(kingston2));
		assertFalse("HardDrives are equal", kingston1.equals(kingston3));
	}

	public void testToString() {
		String in1 = "" + kingston1;
		assertTrue("tostring failed", in1.length() > 0);
	}

	public void testClone() {
		RAM kingston1Clone = (RAM) kingston1.clone();
		assertEquals("RAM blocks are not equal (first way)", kingston1,
				kingston1Clone);
		assertEquals("RAM blocs are not equal (second way)", kingston1Clone,
				kingston1);
	}

}